/*** commaker_controller.rex ***/

::routine buttonClicked1 public
    scene2FXMLUrl =.my.app~appClzLdr~findResource("fxml/spielname.fxml")
    scene2FXML    =.my.app~fxmlLoader~load( scene2FXMLUrl )
    .my.app~scene2=.bsf~new("javafx.scene.Scene", scene2FXML)
    .my.app~primaryStage~setScene(.my.app~scene2)
    .my.app~primaryStage~centerOnScreen

/* --------------------------------------------------------------------------------------------------- */

::routine buttonClicked2 public
    .my.app~primaryStage~close   -- close the window and exit program

/* --------------------------------------------------------------------------------------------------- */

::routine buttonClicked3 public
/* @get(game hb1 hb2 hb3 hb4 hb5 invisibleLabel) */
    hb1~visible=.false
    hb2~visible=.false
    hb3~visible=.true
    hb4~visible=.true
    hb5~visible=.true

    invisibleLabel~text = game~text

/* --------------------------------------------------------------------------------------------------- */

::routine buttonClicked4 public
/* @get(players points invisibleLabel) */
    say invisibleLabel~text
    invisibleLabel~text = invisibleLabel~text || ";" || players~text || ";" || points~text
    points~text = ""
    players~text = ""
    say invisibleLabel~text

/* --------------------------------------------------------------------------------------------------- */

::routine buttonClicked5 public
/* @get(invisibleLabel) */
    iltext= invisibleLabel~text
    parse var iltext gamename ";" playerspoints

    xDesktop         = UNO.createDesktop()
    xComponentLoader = xDesktop~XComponentLoader
    url              = "private:factory/scalc"
    calcComponent    = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)
    xSheet           = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

    call uno.setCell xSheet, 0, 0, (gamename)
    call uno.setCell xSheet, 0, 1, "Erstellt am ".datetime~new
    call uno.setCell xSheet, 0, 3, "Name:"
    call uno.setCell xSheet, 1, 3, "Punkte:"
    call uno.setCell xSheet, 4, 0, "Name:"
    call uno.setCell xSheet, 5, 0, "Gesamtpunkte:"

    /* rekursive construction for player/point */
    i = 1
    do forever
        if playerspoints = "" then leave
        parse var playerspoints player ";" point ";" playerspoints
        call uno.setCell xSheet, 0, i+3, (player)
        call uno.setCell xSheet, 1, i+3, (point)
        call uno.setCell xSheet, 4, i, (player)
        call UNO.setCell xSheet, 5, i, "=SUMIF(A4:A10; """ || (player) || """; B4:B10)"
        i = i + 1
	end

    xCellRangeProps = xSheet~XCellRange~getCellRangeByName("A1:F1")~XPropertySet
    bold            = box("float", bsf.getConstant("com.sun.star.awt.FontWeight", "BOLD"))
    xCellRangeProps~setPropertyValue("CharWeight", bold)

    xCols    = xSheet~XColumnRowRange~getColumns
    xCol     = xCols~getByIndex(0)
    props    = xCol~XPropertySet
    oldWidth = props~getPropertyValue("Width")
    newWidth = oldWidth+i*250
    props~setPropertyValue("Width", box("int",newWidth))

    xCellA4 = xSheet~getCellByPosition(0, 3)
    cbc     = box("int", "CF E7 F5"x ~c2d)
    xCellA4~XPropertySet~setPropertyValue("CellBackColor", cbc)

    xCellB4 = xSheet~getCellByPosition(1, 3)
    cbc     = box("int", "CF E7 F5"x ~c2d)
    xCellB4~XPropertySet~setPropertyValue("CellBackColor", cbc)

    xCell          = xSheet~getCellByPosition(0, 1)
    xPropertySet01 = xCell~XPropertySet~setPropertyValue("CharColor", box("int", "ff 00 00"x ~c2d))

    userHome = .java.lang.System~getProperty("user.home")
    fileName = "competitionmaker.ods"
    storeURL = uno.convertToUrl(userHome"/Documents/"fileName)
    calcComponent~XStorable~storeAsURL(storeURL, .UNO~noProps)
    say "New document saved to" pp(uno.convertFromUrl(storeUrl))

    calcComponent~XModifiable~setModified(.false)

    .my.app~primaryStage~close

::requires UNO.CLS